<?php
/**
 * 上传表
 */
 
# 定义几个常用的选项
$option = array
(
	1 => '启用',
	2 => '关闭',
);

$type = array
(
	1 => '左上',
	2 => '左下',
	3 => '右上',
	4 => '右下',
	5 => '居中',
	6 => '上中',
	7 => '下中',
);


return array
(
	# 表名
	'name' => 'pic_crop',
	# 显示给用户看的名称
	'lang' => '图片裁剪配置',
	'menu' => false,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '配置ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-24',
			'name' 		=> '配置名',
			'default' 	=> '',
			'desc' 		=> '请输入配置名',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),

		'type'		=> array
		(
			'type' 		=> 'int-1',
			'name' 		=> '裁剪位置',
			'default' 	=> '1',
			'desc' 		=> '裁剪位置',
			'match' 	=> 'is_numeric',
			'option' 	=> $type,
			'update'	=> 'select',
			'list'		=> true,
		),
		
		'width'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '宽度',
			'default' 	=> '0',
			'desc' 		=> '请输入宽度',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),
		
		'height'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '高度',
			'default' 	=> '0',
			'desc' 		=> '请输入高度',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	# 默认值
	'default' => array
	(
		'col' => 'name,type,width,height,state,cdate',
		'value' => array
		(
			'"300*300",5,"300","300",1,' . time(),
		),
	),
	# request 请求接口定义
	'request' => array
	(
		# info 取一条正常的数据
		'info' => array
		(
			# 匹配的正则或函数 必填项
			'where' => array
			(
				'id' => 'is_numeric',
				'state' => 1,
			),
			'type' => 'one',
		),
	),
);
