<?php
/**
 * 上传表
 */
 
# 定义几个常用的选项
$option = array
(
	1 => '启用',
	2 => '关闭',
);

return array
(
	# 表名
	'name' => 'pic_thumb',
	# 显示给用户看的名称
	'lang' => '图片缩略配置',
	'menu' => false,
	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '配置ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'search'	=> 'order',
			'list'		=> true,
		),
		
		'name'		=> array
		(
			'type' 		=> 'varchar-24',
			'name' 		=> '配置名',
			'default' 	=> '',
			'desc' 		=> '请输入配置名',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
		),
		
		'width'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '宽度',
			'default' 	=> '0',
			'desc' 		=> '请输入宽度',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),
		
		'height'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '高度',
			'default' 	=> '0',
			'desc' 		=> '请输入高度',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),

		'compress'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '压缩质量-为空或者小于等于0则不进行压缩',
			'default' 	=> '0',
			'desc' 		=> '请输入压缩质量',
			'match' 	=> 'option',
			'update'	=> 'text',
			'list'		=> true,
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	# 默认值
	'default' => array
	(
		'col' => 'name,width,height,state,cdate',
		'value' => array
		(
			'"500",500,0,1,' . time(),
			//'"330*165",330,165,1,' . time(),
			//'"1340*760",1340,760,1,' . time(),
			//'"420*420",420,420,1,' . time(),
			//'"300*140",300,140,1,' . time(),
			//'"580*230",580,230,1,' . time(),
		),
	),

	# request 请求接口定义
	'request' => array
	(
		# info 取一条正常的数据
		'info' => array
		(
			# 匹配的正则或函数 必填项
			'where' => array
			(
				'id' => 'is_numeric',
				'state' => 1,
			),
			'type' => 'one',
		),
	),
);
