<?php
/**
 * 上传表
 */

$type = array
(
    1 => '阿里云',
    2 => '七牛云',
);
return array
(
    # 表名
    'name' => 'yun',
    # 显示给用户看的名称
    'lang' => '云端配置',
    'order' => 1,
    'end' => array
    (
        'insert' => 'upload/lib/config.create',
        'update' => 'upload/lib/config.create',
    ),
    # 数据结构
    'struct' => array
    (
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => '配置ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'list'      => true,
        ),
        
        'name'      => array
        (
            'type'      => 'varchar-24',
            'name'      => '配置名',
            'default'   => '',
            'desc'      => '请输入配置名',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

        'type'     => array
        (
            'type'      => 'int-1',
            'name'      => '存储类别-oss建议申请sts保证安全性，参考https://help.aliyun.com/document_detail/100624.html',
            'default'   => '2',
            'desc'      => '存储类别',
            'match'     => 'is_numeric',
            'option'    => $type,
            'update'    => 'radio',
            'list'      => true,
            'control'   => 'type',
        ),

        'host'      => array
        (
            'type'      => 'varchar-800',
            'name'      => '域名',
            'default'   => '',
            'desc'      => '域名',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),
        
        'appkey'      => array
        (
            'type'      => 'varchar-100',
            'name'      => 'appkey',
            'default'   => '',
            'desc'      => 'appkey',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

        'appsecret'      => array
        (
            'type'      => 'varchar-200',
            'name'      => 'appsecret',
            'default'   => '',
            'desc'      => 'appsecret',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'list'      => true,
        ),

        'region_id'      => array
        (
            'type'      => 'varchar-200',
            'name'      => '区域id-oss直接填RegionId即可，如beijing，七牛可填写z1',
            'default'   => '',
            'desc'      => 'appsecret',
            'match'     => 'is_string',
            'update'    => 'text',
        ),

        'role_arn'      => array
        (
            'type'      => 'varchar-200',
            'name'      => '权限策略ARN-oss需要填写，如未填写，系统默认使用非sts形式上传至oss，不能保证安全性',
            'default'   => '',
            'desc'      => 'appsecret',
            'match'     => 'option',
            'update'    => 'text',
            'show'      => 'type=1',
        ),

        'token'      => array
        (
            'type'      => 'varchar-800',
            'name'      => 'token',
            'default'   => '',
            'desc'      => 'token',
            'match'     => 'option',
        ),

        'token_endtime'      => array
        (
            'type'      => 'int-11',
            'name'      => 'token失效时间',
            'default'   => '',
            'desc'      => 'token',
            'match'     => 'option',
        ),
        
        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '录入时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),
    
    
    'manage' => array
    (
        
    ),
);
