<?php
namespace Upload\Lib\Store;

use Dever;
//use Upload\Lib\Lib\Img;
use Dever\Support\Img;

class Local extends Core implements Config
{
	public $yun = false;
	/**
     * 创建文件和目录
     * 
     * @return mixed
     */
	public function save()
	{
		$this->root();
		
		$this->getName();
		
		# 不覆盖
		if (is_file($this->output['file']) && $this->config['cover'] == 2) {
			$this->output['status'] = -1;
			$this->output['message'] = '文件已经存在';
		} else {
			# 不覆盖 生成新文件
			if (is_file($this->output['file']) && $this->config['cover'] == 3) {
				// . microtime() . rand(0,1000)
				$this->name($this->output['file'] . '_' . microtime() . '_' . rand(0,1000))->file();
			} else {
				$file = Dever::load('upload/file-name', array('where_name' => $this->name, 'where_upload' => $this->data['key'], 'rand' => time()));
			}

			if ($this->base64) {
				file_put_contents($this->output['file'], $this->data['file']['tmp_name']);
			} elseif (!copy($this->data['file']['tmp_name'], $this->output['file'])) {
				$this->output['status'] = -1;
				$this->output['message'] = '文件已经存在';
			} else {
				//unlink($this->data['file']['tmp_name']);
			}

			if (!$this->limit && ($this->ext == '.jpg' || $this->ext == '.gif' || $this->ext == '.png')) {
				$this->limit = getimagesize($this->output['file']);
			}

			if (!$this->size) {
				$this->size = filesize($this->output['file']);
			}
			
			if (isset($file) && $file) {
				$this->update($file['id']);
			} else {
				$this->insert();
			}

			@chmod($this->output['file'], 0755);
            //@system('chmod -R 777 ' . $this->output['file']);

			return $this->output['url'];
		}
	}

	public function file()
	{
		if ($this->base64 && isset($this->data['local'])) {
			$this->data['local'] = str_replace(Dever::data() . 'upload/', '', $this->data['local']);
			$this->file = $this->data['local'] . $this->name . $this->ext;
		} else {
			$this->file = $this->path . $this->name . $this->ext;
		}
		$this->output['file'] = is_file($this->base . $this->file) ? $this->base . $this->file : Dever::path($this->base, $this->file);
		$this->output['url'] = Dever::config('host')->uploadRes . $this->file;

		return $this->output['file'];
	}

	/**
     * water
     * 
     * @return mixed
     */
	public function handle_w($id)
	{
		$config = Dever::load('upload/pic_water-one', $id);
		if ($config) {
			$this->name .= '_w' . $id;
			
			$water = array('water'=> $config['water'], 'position'=> ($config['water_position'] ? $config['water_position'] : 1));
			
            $this->img()->mark($this->output['file'], $water, true, $this->file());

            Dever::config('base')->handle_w = $this->output['file'];
		}
	}

	/**
     * compress
     * 
     * @return mixed
     */
	public function handle_p($num, $source = false, $dest = false)
	{
		if (is_array($num)) {
			return;
		}
		
		if (!$source) {
			$source = $this->output['file'];
		}

		if (!$dest) {
			if (strpos($this->name, '_p') !== false) {
				$temp = explode('_p', $this->name);
				$this->name = $temp[0];
			}

			$file = $this->output['file'];
			$url = $this->output['url'];

			$this->name .= '_p' . $num;
			$dest = $this->file();

			$this->output['file'] = $file;
			$this->output['url'] = $url;
		}

		$this->img()->setType('im');
		$this->img()->compress($source, $num, $dest);

		return $dest;
	}
	
	/**
     * webp
     * 
     * @return mixed
     */
	public function handle_wp($num, $source = false, $dest = false)
	{
		if (is_array($num)) {
			return;
		}

		if (!$source) {
			$source = $this->output['file'];
		}


		if (!$dest) {
			if (strpos($this->name, '_wp') !== false) {
				$temp = explode('_wp', $this->name);
				$this->name = $temp[0];
			}

			$file = $this->output['file'];
			$url = $this->output['url'];

			$this->ext = '.webp';
			$this->name .= '_wp' . $num;
			$dest = $this->file();

			$this->output['file'] = $file;
			$this->output['url'] = $url;
		}

		$this->img()->setType('im');
		$this->img()->webp($source, $num, $dest);

		return $dest;
	}

	/**
     * thumb
     * 
     * @return mixed
     */
	public function handle_t($id, $source = false, $dest = false)
	{
		$config = Dever::load('upload/pic_thumb-one', $id);
		if ($config) {

			if (!$source) {
				$source = $this->output['file'];
			}

			if (!$dest) {
				if (strpos($this->name, '_t') !== false) {
					$temp = explode('_t', $this->name);
					$this->name = $temp[0];
				}
				$this->name .= '_t' . $id;
				$dest = $this->file();
			}		
			
			$size = $config['width'] . '_' . $config['height'] . '_2';

            $this->img()->thumb($source, $size, true, $dest);

            # 同时进行压缩
            if (isset($config['compress']) && $config['compress'] > 0) {
				$this->img()->setType('im');
				$this->img()->compress($dest, $config['compress'], $dest);
            }
		}

		return $dest;
	}
	
	/**
     * crop
     * 
     * @return mixed
     */
	public function handle_c($id, $source = false, $dest = false)
	{
		$config = Dever::load('upload/pic_crop-one', $id);

		if ($config) {

			if (!$source) {
				$source = $this->output['file'];
			}

			if (!$dest) {
				if (strpos($this->name, '_c') !== false) {
					$temp = explode('_c', $this->name);
					$this->name = $temp[0];
				}
				$this->name .= '_c' . $id;
				$dest = $this->file();
			}
			
			$size = $config['width'] . '_' . $config['height'] . '_2';

            $this->img()->crop($source, $size, $config['type'], true, $dest);
		}

		return $dest;
	}
}
