<?php
namespace Upload\Lib\Store;

use Dever;
class Oss extends Core implements Config
{
    public $yun = true;
    /**
     * 上传文件
     * 
     * @return mixed
     */
    public function save()
    {
        list($yun, $file) = $this->yun();

        $options = array();

        $method = Dever::load('upload/lib/view/oss')->connect($yun, $this->config, $file);

        $ret = $method->upload($this->config['bucket'], $file, $this->data['file']['tmp_name'], $options, $this->base64);

        if (isset($ret['info']['url'])) {

            $this->file = $this->output['url'];
            $file = Dever::load('upload/file-name', array('where_name' => $this->name, 'where_upload' => $this->data['key'], 'rand' => time()));
            
            if (!$this->limit) {
                $data = Dever::curl($this->output['url'] . '?x-oss-process=image/info');
                if ($data) {
                    $data = json_decode($data, true);
                    if (isset($data['ImageWidth']['value'])) {
                        $this->limit = array($data['ImageWidth']['value'], $data['ImageHeight']['value']);
                        $this->size = $data['FileSize']['value'];
                        $this->ext = '.' . $data['Format']['value'];

                        $this->limit();
                        if ($this->output['status'] == -1) {
                            $method->delete($this->bucket, $this->file);
                            return $this->output;
                        }
                    }
                }
            }
            
            if (isset($file) && $file) {
                $this->update($file['id']);
                
            } else {
                $this->insert();
            }

            return $this->output['url'];
        }
    }

    public function file()
    {
        if ($this->base64 && isset($this->data['local'])) {
            $data = parse_url($this->data['local']);
            $data['path'] = str_replace(Dever::data() . 'upload/', '', $data['path']);
            $this->path = ltrim($data['path'], '/');
        }
        $this->file = $this->path . $this->name . $this->ext;

        $this->output['file'] = $this->file;
        $this->output['url'] = $this->host . $this->file;
        
        //$this->output['url'] = '{uploadYun}' . $this->file;
        return $this->output['file'];
    }
    
    /**
     * water
     * 
     * @return mixed
     */
    public function handle_w($id)
    {
        $config = Dever::load('upload/pic_water-one', $id);
        if ($config) {
            $this->name .= '_w' . $id;
            
            $water = array('water'=> $config['water'], 'position'=> ($config['water_position'] ? $config['water_position'] : 1));
            
            $this->img()->mark($this->output['file'], $water, true, $this->file());
        }
    }

    /**
     * compress
     * 
     * @return mixed
     */
    public function handle_p($num, $source = false, $dest = false)
    {
        if (!$source) {
            $source = $this->output['file'];
        }

        if (!$dest) {
            if (strpos($this->name, '_p') !== false) {
                $temp = explode('_p', $this->name);
                $this->name = $temp[0];
            }

            $file = $this->output['file'];
            $url = $this->output['url'];

            $this->name .= '_p' . $num;
            $dest = $this->file();

            $this->output['file'] = $file;
            $this->output['url'] = $url;
        }

        $this->img()->setType('im');
        $this->img()->compress($source, $num, $dest);
    }
    
    /**
     * webp
     * 
     * @return mixed
     */
    public function handle_wp($num, $source = false, $dest = false)
    {
        if (!$source) {
            $source = $this->output['file'];
        }


        if (!$dest) {
            if (strpos($this->name, '_wp') !== false) {
                $temp = explode('_wp', $this->name);
                $this->name = $temp[0];
            }

            $file = $this->output['file'];
            $url = $this->output['url'];

            $this->ext = '.webp';
            $this->name .= '_wp' . $num;
            $dest = $this->file();

            $this->output['file'] = $file;
            $this->output['url'] = $url;
        }

        $this->img()->setType('im');
        $this->img()->webp($source, $num, $dest);
    }

    /**
     * thumb
     * 
     * @return mixed
     */
    public function handle_t($id, $source = false, $dest = false, $path = '')
    {
        $config = Dever::load('upload/pic_thumb-one', $id);
        if ($config) {

            if (!$source) {
                $source = $this->output['file'];
            }

            //?imageView2/2/w/360/h/270/format/png/q/75|imageslim
            //?x-oss-process=image/resize,q_50
           // $dest = $source . '?imageView2/2/w/'.$config['width'].'/h/'.$config['height'];
            if (!strstr($source, 'http')) {
                $source = $this->data['host'] . $source;
            }
            if (strstr($source, '?')) {
                $prefix = '&';
            } else {
                $prefix = '?';
            }

            $dest = $source . $prefix . 'x-oss-process=image/resize,m_lfit,w_'.$config['width'].',h_' . $config['height'];

            if (isset($config['compress']) && $config['compress'] > 0) {
                $dest .= ',q_' . $config['compress'];
            }
        } else {
            $dest = $this->data['host'] . $source;
        }
        return $dest;
    }
    
    /**
     * crop
     * 
     * @return mixed
     */
    public function handle_c($id, $source = false, $dest = false)
    {
        $config = Dever::load('upload/pic_crop-one', $id);
        
        if ($config) {

            if (!$source) {
                $source = $this->output['file'];
            }

            if (!strstr($source, 'http')) {
                $source = $this->data['host'] . $source;
            }
            if (strstr($source, '?')) {
                $prefix = '&';
            } else {
                $prefix = '?';
            }

            $dest = $source . $prefix . 'x-oss-process=image/resize,fill,w_'.$config['width'].',h_' . $config['height'];
        }
        return $dest;
    }
}
